class PcCounter extends React.Component
{
  constructor(props)
  {
    super(props);
    this.state = {display:true, counterVal:props.startVal, startVal:props.startVal}
    this.playing = false;
    this.interval = null;
    this.countNumber = React.createRef();
    this.showLong = true;
  }

  show()
  {
    this.setState({display:true});
  }

  hide()
  {
    this.setState({display:false});
  }

  showLongCounter(b)
  {
    this.showLong = b;
  }

  initCount()
  {
    this.interval = setInterval(async ()=>{await this.doCount()}, this.props.delay);
    this.playing = true;
  }

  pauseCount()
  {
    clearInterval(this.interval);
  }

  changeStartVal(n)
  {
    this.state.startVal = n;
  }

  resetCount()
  {
    this.playing = false;
    this.state.counterVal=this.state.startVal;
    clearInterval(this.interval);
  }

  async doCount()
  {
    if (this.state.counterVal-1>0)
    {
      this.countNumber.current.style.display="none";
      this.setState({counterVal:this.state.counterVal-1});
      setTimeout(()=>{this.countNumber.current.style.display="table-cell";}, 100);

      if (this.state.counterVal==1)
      {
        //PcConfig.sounds.counter1.play();
      }
      else if (this.state.counterVal == 2 || this.state.counterVal == 3) {
        //PcConfig.sounds.counter2.play();
      }

      await this.props.onCount(this.state.counterVal);
    }
    else
    {
        this.resetCount();
        this.props.onEndCount();
    }
  }

  render()
  {
    var val;

    if (this.state.counterVal>3 && !this.showLong)
    {
      val = "";
    }
    else {
      val = this.state.counterVal;
    }


    return e('div',
      {
        className:"pcelementshowanimation",
        style:
        {
          display:this.state.display?"block":"none",
          opacity:this.props.noAnimation?1:0,
          animation:this.props.noAnimation?"":PcConfig.scenario.elementsAnimationStyle,
          animationFillMode:"forwards",
          animationDelay:this.props.showDelay
        }
      },
      e('div',
        {
          className:"pccounter",
          style:
            {
              width:this.props.width,
              height:this.props.height,
              left:this.props.x,
              top:this.props.y,
              display:"table",
              overflow:"auto",
              fontFamily:PcConfig.scenario.fontFamily,
              fontSize:this.props.height + "px",
              color:this.props.color,
            },
        },
        e('div',
          {
            ref:this.countNumber,
            style:
            {
              display:"table-cell",
              verticalAlign: "middle",
              textAlign: "center",
              opacity:1,
              animation: "numberFadeOut " + this.props.delay + "ms ease-in",
              textShadow: this.props.shadow,
            },
          },
          val
        )
      )
    );
  }
}
