class PcSliderTemplateAndFilter extends React.Component
{
  constructor(props)
  {
    PcDbg.log(REMOVEDBG|CRASHDBG, "entering constructor");
    super(props);

    this.reseted = false;

    this.mainSlides = [];
    this.navSlides = []

    this.mainSlidesSimpleMode = false;
    this.navSlidesSimpleMode = false;

    this.lastClickTime = Date.now();
    this.autoNextTime = 100*1;

    let format_index = PcConfig.getMemory("currentFormatIndex");
    let rbgResult;
    rbgResult = PcConfig.getMemory("shootsRemoveBgResult"); // check if removeBg worked (synchronous job) after PcScreenLoading
    //rbgResult = false; // WARNING: TEST
    let rbgWasAsked = PcRemoveBg.isOn(format_index) || PcRemoveBg.isOptional(format_index); // on + (opt-on, opt-off)
    let rbgWasAskedOptOff = (! PcRemoveBg.isOn(format_index) ) && PcRemoveBg.isOptional(format_index); // opt-off
    this.showRbgToggleButton = rbgResult && PcRemoveBg.isOptional(format_index); // show button if rbg worked ok and modes are OPTIONAL  ON or OFF 
    this.showRbgErrMsg = rbgWasAsked && !rbgResult; // show error message is rbg failed and requested mode was not OFF  
    this.rbgButtonState = PcRemoveBg.isOn(format_index) ; // the initial state of the rbgtogglebutton should be = to optional mode

    this.useRemoveBg = rbgResult  && ! rbgWasAskedOptOff;
    this.commitRbgMemory();
    
    PcDbg.log(REMOVEDBG, "|format_index", format_index);
    PcDbg.log(REMOVEDBG, "|rgbWasAsked", rbgWasAsked, "rbgResult", rbgResult);
    PcDbg.log(REMOVEDBG, "|show: rbgToggleButton", this.showRbgToggleButton, "errMsg", this.showRbgErrMsg);
    PcDbg.log(REMOVEDBG, "|rbgButtonState:", this.rbgButtonState);
    PcDbg.log(REMOVEDBG, "|Initial useRmoveBg:", this.useRemoveBg);

    this.rbgToggleButton = React.createRef();

  }

  async reset() // FIXME where should I be awaited?
  {
    PcDbg.log(REMOVEDBG|CRASHDBG, "enter reset");
    if (this.reseted) return;

    $('.mainslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow: this.mainSlidesSimpleMode ? this.props.skins[this.props.formatIndex].length : 1,
          slidesToScroll: 1,
          centerMode: this.mainSlidesSimpleMode ? false : true,
          variableWidth: true,
          swipeToSlide: this.mainSlidesSimpleMode ? false : true,
          swipeAngleOffset: 90,
          touchThreshold : 10,
          speed:300,
          cssEase:"cubic-bezier(0, 0, 0.1, 1.0)",
          focusOnSelect: true,
          arrows:false,
        });

    $('.navslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow: this.navSlidesSimpleMode ? PcConfig.screen.templateAndFilter.filters.length : 1,
          slidesToScroll: 1,
          centerMode: this.navSlidesSimpleMode ? false : true,
          variableWidth: true,
          swipeToSlide: this.navSlidesSimpleMode ? false : true,
          swipeAngleOffset: 90,
          touchThreshold : 10,
          speed:300,
          cssEase:"cubic-bezier(0, 0, 0.1, 1.0)",
          focusOnSelect: true,
          arrows:false,
        });

    $('.mainslider_' + this.props.name).on('beforeChange', (event, slick, currentSlide, nextSlide) => {
      this.changeMainSlide(nextSlide);
    });

    $('.navslider_' + this.props.name).on('beforeChange', async (event, slick, currentSlide, nextSlide) => {
      await this.changeNavSlide(nextSlide);
    });

    $('.mainslider_' + this.props.name).slick("slickGoTo", PcConfig.getMemory("currentSkinIndex"));
    $('.mainslider_' + this.props.name).slick("setPosition");
    this.lastClickTime = Date.now();
    this.onTouchMainSlide(PcConfig.getMemory("currentSkinIndex"), true);

    $('.navslider_' + this.props.name).slick("slickGoTo", PcConfig.getMemory("currentFilterIndex"));
    $('.navslider_' + this.props.name).slick("setPosition");
    await this.onTouchNavSlide(PcConfig.getMemory("currentFilterIndex"), true);

    for (let i=0; i<this.mainSlides.length && this.mainSlides[i]!=null; i++) {
      if (this.mainSlides[i]) {
         this.mainSlides[i].current.start();
      }
    }

    this.reseted = true;
    PcDbg.log(REMOVEDBG|CRASHDBG, "exit reset");
  }

  changeMainSlide(index, forced=false)
  {
    //if (PcConfig.getMemory("currentSkinIndex")==index && !forced) return;

    if (PcConfig.getMemory("currentSkinIndex")==index && !forced)
    {
      return;
    }
    else {
      this.lastClickTime = Date.now();
    }

    PcConfig.setMemory("currentSkin", this.mainSlides[index].current.props.skin);
    PcConfig.setMemory("currentSkinIndex", index);
  }

  onTouchMainSlide(index, forced=false)
  {
    if (PcConfig.getMemory("currentSkinIndex")==index)
    {
      if (PcConfig.screen.templateAndFilter.filters.length<=1)
      {
        if (Date.now()-this.lastClickTime>this.autoNextTime) this.props.onSelectSlide();
      }
    }

    if (this.mainSlidesSimpleMode)
    {
      this.lastClickTime = Date.now();
      $('.mainslider_' + this.props.name).slick("setSlideClasses", index);
      this.changeMainSlide(index, forced);
    }
  }

  async refreshNavSlides() // when we need to recompute the navslides thumbnails (small ones), for instance when we switch from rbg opt-on to rbg opt-off
  {
    for (var i=0; i<PcConfig.screen.templateAndFilter.filters.length; i++) {
      await this.navSlides[i].current.composeFramesWithSelectedFilter(PcConfig.screen.templateAndFilter.filters[i], /*useRemoveBg = */ this.useRemoveBg);  // FIXME
    } 
  }

  async changeNavSlide(index, forced=false)
  {
    PcDbg.log(REMOVEDBG|CRASHDBG, "entering with index", index, "forced ?", forced)
    if (PcConfig.getMemory("currentFilterIndex")==index && !forced) return;

    for (let i=0; i<this.mainSlides.length && this.mainSlides[i]!=null; i++)
    {
      //PcDbg.log(REMOVEDBG, "this.mainslides[",i,"].current", this.mainSlides[i].current);
      //PcDbg.log(REMOVEDBG, "this.navslides[",i,"].current.props.filter_dict", JSON.stringify(this.navSlides[i].current.props.filter_dict));
      await this.mainSlides[i].current.composeFramesWithSelectedFilter(this.navSlides[index].current.props.filter_dict, /*useRemoveBg = */ this.useRemoveBg); 
    }

    PcConfig.setMemory("currentFilterDict", this.navSlides[index].current.props.filter_dict);
    PcConfig.setMemory("currentFilterIndex", index);
    PcDbg.log(REMOVEDBG|CRASHDBG, "exiting")
  }

  async onTouchNavSlide(index, forced=false)
  {
    PcDbg.log(REMOVEDBG|CRASHDBG, "entering", index, forced);
    if (this.navSlidesSimpleMode)
    {
      $('.navslider_' + this.props.name).slick("setSlideClasses", index);
      await this.changeNavSlide(index, forced);
    }
    PcDbg.log(REMOVEDBG|CRASHDBG, "exiting")
  }

  onDoubleTouchMainSlide(index)
  {
    this.onTouchMainSlide(index);
    this.props.onSelectSlide();
  }

  delete()
  {
    for(let i=0; i<this.mainSlides.length; i++)
    {
      if (this.mainSlides[i] && this.mainSlides[i].current)
      {
        this.mainSlides[i].current.delete();
      }
      this.mainSlides[i] = null;
    }

    for(let i=0; i<this.navSlides.length; i++)
    {
      if (this.navSlides[i] && this.navSlides[i].current)
      {
        this.navSlides[i].current.delete();
      }
      this.navSlides[i] = null;
    }

    $('.mainslider_' + this.props.name).slick('unslick');
    $('.navslider_' + this.props.name).slick('unslick');
  }

  commitRbgMemory()
  {
    PcConfig.setMemory("useRemoveBgChoice", this.useRemoveBg);
  }
  async onRbgButtonClick()
  {
    var cfi = PcConfig.getMemory("currentFilterIndex");
    PcDbg.log(REMOVEDBG, "initial button state:", this.rbgButtonState);
    this.rbgButtonState = ! this.rbgButtonState;
    this.useRemoveBg = this.rbgButtonState;
    this.commitRbgMemory();
    await this.refreshNavSlides();
    await this.onTouchNavSlide(cfi, true);
    //this.onTouchMainSlide(cfi, true); // ?

    PcDbg.log(REMOVEDBG, "final button state:", this.rbgButtonState);
   
  }
  componentDidUpdate()
  {
    
    PcDbg.log(REMOVEDBG|CRASHDBG, "entering");
    if (this.props.active) this.reset();
  }

  componentDidMount()
  {
    PcDbg.log(REMOVEDBG|CRASHDBG, "entering");
    if (this.props.active) this.reset();
  }

  render()
  {
    if (!this.props.active) return null;

    if (this.props.active && !this.reseted)
    {
      for (var i=0; i<this.props.skins[this.props.formatIndex].length; i++) this.mainSlides[i] = React.createRef();
      for (var i=0; i<PcConfig.screen.templateAndFilter.filters.length; i++) this.navSlides[i] = React.createRef();
      this.mainSlidesSimpleMode = this.props.skins[this.props.formatIndex].length <= 2;
      this.navSlidesSimpleMode = PcConfig.screen.templateAndFilter.filters.length <= 8;
    }
    else {
      if (!this.props.keepState)
      {
        this.reseted = false;
        this.delete();
        return null;
      }
    }
    // count the number of lines in the title, as we nned to reduce the sliderheight accordingly IF we show RbgToggleButton
    let title_line_count_minus_1 = Math.max(0, (PcConfig.screen.templateAndFilter.title.match(/<br>/g) || []).length -1 );
    let currentFilterDict = PcConfig.screen.templateAndFilter.filters[0];
    let labelClipping = PcConfig.screen.templateAndFilter.clippingLabel ? PcConfig.screen.templateAndFilter.clippingLabel : "Détourage";
    let labelClippingFailed = PcConfig.screen.templateAndFilter.clippingFailedLabel ? PcConfig.screen.templateAndFilter.clippingFailedLabel : "(Détourage temporairement indisponible)";
    let slideWidth, navWidth, sliderWidth;

    let needFilters = (PcConfig.screen.templateAndFilter.filters.length>1);

    let mainSliderHeight = needFilters ? this.props.height*0.66 : this.props.height;
    if (this.showRbgToggleButton) {
      // reduce the slider height for it to be not too low on layout
      mainSliderHeight -= (title_line_count_minus_1) * parseInt(PcConfig.scenario.fontSize, 10); // title has more than 1 line, make slider height smaller to make room for the removebg label and button
    }
    let navSliderHeight = needFilters ? this.props.height*0.33 : 0;

    slideWidth = this.props.width * 0.25;
    navWidth = this.props.width*0.9*this.props.skins[this.props.formatIndex].length/6;
    if (navWidth>this.props.width*0.9) navWidth = this.props.width*0.9;

    let mainSlides = [];
    let ratio = PcMode.screen.templateAndFilter.slidersRatio;
    sliderWidth = 0;

    switch (PcConfig.screen.format.formats[this.props.formatIndex].paper)
    {
        case "10x15" : slideWidth = this.props.width * 0.25 * ratio; break;
        case "15x10" : slideWidth = this.props.width * 0.4 * ratio; break;
        case "5x15" : slideWidth = this.props.width * 0.12 * ratio; break;
        case "15x15" : slideWidth = this.props.width * 0.25 * ratio; break;
    }

    if (PcConfig.device=="surface") slideWidth *= 1.33;

    sliderWidth = this.props.skins[this.props.formatIndex].length * slideWidth;

    if (this.mainSlidesSimpleMode && sliderWidth>this.props.width)
    {
      slideWidth = this.props.width/2;
      sliderWidth = this.props.width;
    }

    let rbgToggleButton = null;
    let rbgErrorMessage = null;
    let rbg_label_and_slider_y = this.props.y + (this.showRbgToggleButton ? (title_line_count_minus_1 * parseInt(PcConfig.scenario.fontSize, 10)) : 0); // shift the slidercontainer so the rbg label and button are below the title text
    let space_between_main_label_and_rbg_label = (rbg_label_and_slider_y /*bottom */ - this.props.rbg_label_y_offset /* top */ );
    let rbg_center_offset = space_between_main_label_and_rbg_label / 2;
    if (this.showRbgToggleButton) {
          PcDbg.log(REMOVEDBG, "rbgToggleButton is", rbgToggleButton);

         rbgToggleButton = e('div',
             {
                className:"removebg_"+this.props.name,
                style:
                {
                  top: -rbg_center_offset,
                  position:"relative",
                  display:"inline-flex",
                  alignItems:"center",
                  justifyContent: "center", //  : "flex-start",
                  flexWrap: "wrap",
                  alignContent:"left",
                  justifyContent:"left",
                  overflow:"hidden",
                  }
              },
              e(PcLabel,
                {
                  key: "rbglabeldetourage",
                  title:false,
                  position:"relative",
                  display:"inline-flex",
                  label:labelClipping,
                  visibility: "visible",
                  fontSize:PcConfig.scenario.fontSize,
                  color: PcConfig.scenario.fontColor,
                  height:  (parseInt(PcConfig.scenario.fontSize, 10) * 1.5).toString() +"px",  // à vue sur l'inspecteur de layout de devtools
                }
              ),
              e(PcFormToggleButton,
                  {
                    key:"rbgtogglebutton",
                    ref:this.rbgToggleButton,
                    onClick:()=>this.onRbgButtonClick(),
                    active:this.props.active,
                    sound : PcConfig.sounds.buttonPrevious,
                    position:"relative",
                    visibility:true,
                    fontSize:PcConfig.scenario.fontSize,
                    color: PcConfig.scenario.fontColor,
                    spacingHLeft:5*PcConfig.renderSize,
                    spacingHRight:5*PcConfig.renderSize,
                    spacingV:5*PcConfig.renderSize,
                    halign:"left",
                    toggleValue:this.rbgButtonState,
                
                 }
              )
         );
    }
    

   else if (this.showRbgErrMsg) { // one or the other
      PcDbg.log(REMOVEDBG, "preparing PcLabel for failed RBG");
      rbgErrorMessage = 
      e('div',
        {
          style:
            {
              top: -rbg_center_offset,
              position:"relative",
              overflow:"auto",
              width:"100%",
              height:"3%",
              display:"inline-flex",
              justifyContent: "center",
              flexWrap: "wrap",
              alignContent:"center",
              visibility: 1,
              opacity: 1
            }
        },
        e(PcLabel,
          {
           label:labelClippingFailed,
           position: "relative",
           height:"100%",
           fontSize:PcConfig.scenario.fontSizeSmall,
           color: PcConfig.scenario.fontColor,
           halign: "center",
           width: this.props.width,
           showDelay:"0,1s",
           opacity: 1,
           fontStyle: 'italic'
          }
        )
      );
    }
    
    PcDbg.log(REMOVEDBG, ">>>rbgToggleButton is", rbgToggleButton);
    PcDbg.log(REMOVEDBG, ">>>rbgErrorMessage is", rbgErrorMessage);

    for (var i=0; i<this.props.skins[this.props.formatIndex].length; i++)
    {

      mainSlides[i] = ((i)=>{ // those are the filtered and skinned slides, aka mainSlides
        return e('div',
                  {
                    className:"slick-item",
                    key:"img"+i,
                    onTouchEnd:()=>this.onTouchMainSlide(i),
                    onClick:()=>this.onTouchMainSlide(i),
                    style:{height:mainSliderHeight}
                  },
                  e(PcPhoto,
                    {
                      ref:this.mainSlides[i],
                      animationMode:"",
                      preview:false,
                      label:"",
                      format:PcConfig.screen.format.formats[this.props.formatIndex],
                      filter_dict:currentFilterDict,
                      useRemoveBg:this.useRemoveBg,
                      shots: (PcCameraControl.useDSLR()==false && PcCameraControl.webcamActive==false) ? PcCaptureSession.defaultShots : PcCaptureSession.shots,
                      skin:this.props.skins[this.props.formatIndex][i],
                      colors:[this.props.skins[this.props.formatIndex][i].color],
                      backgrounds:[this.props.skins[this.props.formatIndex][i].background],
                      foregrounds:[this.props.skins[this.props.formatIndex][i].foreground],
                      width:slideWidth,
                      height: mainSliderHeight,
                      padding:0,
                    }
                  )
                );
        }
      )(i);

    }

    let mainSliderLeft =  this.mainSlidesSimpleMode ? (this.props.width - sliderWidth)/2 : 0;

    let navSlides = [];
    sliderWidth = 0;

    for (var i=0; i<PcConfig.screen.templateAndFilter.filters.length; i++)
    {

      slideWidth = this.props.width*0.065*PcMode.screen.templateAndFilter.filtersRatio;
      sliderWidth += slideWidth + 15*PcConfig.renderSize*2;

      navSlides[i] = ((i)=>{ // navslides are the small filtered thumbnails. when we click on the rbgToggleButton toggle, they also must be updated
        return e('div',
                  {
                    className:"slick-item",
                    key:"img"+i,
                    onTouchEnd:async ()=> await this.onTouchNavSlide(i),
                    onClick:async ()=> await this.onTouchNavSlide(i),
                    style:{height:navSliderHeight}
                  },
                  e(PcPhoto,
                    {
                      ref:this.navSlides[i],
                      animationMode:"",
                      preview:true,
                      label:PcConfig.screen.templateAndFilter.filters[i].title,
                      format:PcConfig.screen.format.formats[this.props.formatIndex],
                      filter_dict:PcConfig.screen.templateAndFilter.filters[i],
                      useRemoveBg:this.useRemoveBg,
                      shots:(PcCameraControl.useDSLR()==false && PcCameraControl.webcamActive==false) ? PcCaptureSession.defaultShots : PcCaptureSession.shots,
                      colors:[],
                      backgrounds:[this.props.skins[this.props.formatIndex][0].background],
                      foregrounds:[],
                      width:slideWidth,
                      height:slideWidth,
                      padding:15*PcConfig.renderSize,
        
                    }
                  )
                ); // end return e()
              } // end body  
      )(i); // end inline func decluse

    } // end for

    let navSliderLeft =  this.navSlidesSimpleMode ? (this.props.width - sliderWidth) / 2 : 0;
    let rbgWhat = rbgToggleButton? rbgToggleButton:rbgErrorMessage?rbgErrorMessage:null;
    PcDbg.log(REMOVEDBG, "rbgWhat is", rbgWhat, "ie.", + PcDbg.simpleStringify(rbgWhat));

    return e('div',
        {
          className:"pcslidertemplateandfilterscontainer",
          style:
          {
            position:"absolute",
            opacity:0,
            animation:PcConfig.scenario.elementsAnimationStyle,
            animationFillMode:"forwards",
            animationDelay:this.props.showDelay,
            width:this.props.width,
            height:this.props.height,
            left:this.props.x,
            top: rbg_label_and_slider_y,//this.props.y + (this.showRbgToggleButton ? (title_line_count_minus_1 * parseInt(PcConfig.scenario.fontSize, 10)) : 0), // shift the slidercontainer so the rbg label and button are below the title text
            display:"table-cell",
            textAlign:"center",
          }
        },

        rbgWhat,
        
         
        e('div',
         {
          className:"mainslider_"+this.props.name,
          style:{overflow:"hidden",
          left:mainSliderLeft,
          width:this.props.width,
          height:mainSliderHeight}
         },
         mainSlides),
        e('div',
        {
          className:"navslider_"+this.props.name,
          style:{overflow:"hidden",
          left:navSliderLeft,
          width:this.props.width,
          height:navSliderHeight}
        },
        navSlides),
      );
  }
}
