class PcFormToggleButton extends React.Component
{
  static get test() {return "test"}

  constructor(props)
  {
    //PcDbg.log(CRASHDBG, "entering with props", JSON.stringify(props));
    super(props);
    this.state =
      {
        width:props.width,
        padHorizontal:16,
        padVertical:8,
        selected:false,
        
        backgroundColor: this.getBackgroundColor(props.toggleValue),
        label: this.getLabel(props.toggleValue),
        textColor: this.getTextColor(props.toggleValue)
      }

    this.onoff = props.toggleValue;
    this.buttonBackground = React.createRef();
    this.buttonContainer = React.createRef();
  }

  getLabel(toggleValue)
  { 
    let label = toggleValue? "ON ✓" : "OFF ✕";
    return label;

  }
  getBackgroundColor(toggleValue)
  {

    let bgc = toggleValue? PcConfig.screen.infos.okButton.backgroundColor: "#FF000000";
    return bgc;
  }

  getTextColor(toggleValue)
  {
    let txc = toggleValue? PcConfig.screen.infos.okButton.fontColor : PcConfig.scenario.fontColor;
    return txc;
  }
  setToggle(state)
  {
    PcDbg.log(REMOVEDBG, "state:", state);

    let txc = this.getTextColor(state);
    let bgc = this.getBackgroundColor(state);
    let label = this.getLabel(state);
    
    this.setState({textColor: txc, backgroundColor: bgc, label: label })
    
  }

  static predictSize(label)
  {
    var e = document.createElement("canvas");
    var ctx = e.getContext("2d");
    ctx.font = PcConfig.scenario.fontSize + " " + PcConfig.scenario.fontFamily;
    var t= ctx.measureText(label);
    return t.width;
  }

  getWidth()
  {
    return this.buttonBackground.current.getBoundingClientRect().width;
  }

  setWidth(w)
  {
    this.setState({width: w-(2*this.state.padHorizontal*PcConfig.renderSize)-2*PcConfig.scenario.buttonsBorderWidth});
  }

  select()
  {
    this.setState({selected:true});
  }

  unselect()
  {
    this.setState({selected:false});
  }

  isSelected()
  {
    return this.state.selected;
  }

  onClick(e)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    if (this.props.sound) this.props.sound.play();
    this.onoff = !this.onoff;
    this.setToggle(this.onoff);
    if (this.props.onClick){
        this.props.onClick(e);
    }
  }

  render()
  {
    var borderColor = PcConfig.screen.infos.okButton.borderColor;
    // var backgroundColor = PcConfig.screen.infos.okButton.backgroundColor;
    

    if (PcConfig.scenario.buttonsStyle=="rounded")
    {
      var borderRadius = 12 * PcConfig.renderSize;
    }
    else
    {
      var borderRadius = 0;
    }

    var shadow = 5*PcConfig.renderSize;

    return e('div',
        {
          className:"pcokbuttoncontainer",
          ref:this.buttonContainer,
          style:
          { //opacity: 1,
            visibility: "visible",
            transition : "all 0.5s ease-out",
            left: this.props.x,
            top:this.props.y,
            marginLeft: this.props.spacingHLeft,
            marginRight: this.props.spacingHRight,
            marginTop: this.props.spacingV,
            marginBottom: this.props.spacingV,
            opacity:this.props.visibility ? 1 : 0,
          }
        },
        e('div',
          {
            className:"pcchoicebutton",
            ref:this.buttonBackground,
            style:
              {
                opacity: 1,
                visibility: "visible",
                position:"relative",
                width:this.state.width,
                height:this.props.height,
                borderStyle:"solid",
                borderWidth:PcConfig.scenario.buttonsBorderWidth/2,
                borderColor:borderColor,
                backgroundColor:this.state.backgroundColor,
                borderRadius:borderRadius,
                paddingTop:this.state.padVertical*PcConfig.renderSize,
                paddingBottom:this.state.padVertical*PcConfig.renderSize,
                paddingLeft:this.state.padHorizontal*PcConfig.renderSize,
                paddingRight:this.state.padHorizontal*PcConfig.renderSize,
                overflow:"auto",
                fontFamily:PcConfig.scenario.fontFamily,
                fontSize:PcConfig.scenario.fontSizeMedium,
                color:this.state.textColor,
                verticalAlign: "middle",
                textAlign: "center",
                boxShadow: shadow+"px "+shadow+"px "+shadow+"px 0px rgba(0, 0, 0, 0.25)"
              },
              onClick:(e)=>{this.onClick(e)},
              onTouchEnd:(e)=>{this.onClick(e)},
              dangerouslySetInnerHTML:{__html:this.state.label}
          }
        )
    );
  }
}
