class PcScreen extends React.Component
{
  constructor(props)
  {
    super(props);
    PcDbg.log(CRASHDBG, `PCScreen Constructor enter as ${this.constructor["name"]}`);
    this.bar_ref= React.createRef();
    this.state =
    {
      className: "pcscreen",
      animationStyle : PcConfig.scenario.screensAnimationStyle
    };

    this.registeredButtons = [];

    this.bar = null;
    this.delayedBarTimer = null;
    if (this.props.has_paymode_bar_timeout && PcConfig.scenario.payment.active) {
      this.bar = PcProgressBar.craftProgressBar(
        this.bar_ref,
        this.constructor["name"],
        false,
        "100%",
        "5%",
        PcConfig.scenario.payment.timerBarColorInitial,
        PcConfig.scenario.actionButtonTextColor,
        PcConfig.scenario.payment.autoNextStepTimeout,
        PcConfig.scenario.payment.timerBarColorChangeTime,
        PcConfig.scenario.payment.timerBarColorFinal,
        "1s",
        null,
        (x)=>{this.onEndProgress(x)},
        PcConfig.sounds.barAppearance
        );
    }
  }

  onClick() 
  {
    PcDbg.log(CRASHDBG, "RESET BAR + TIMER IF ANY");
    if (this.bar) {
      this.resetDelayedBarTimer();
    }
  }

  resetDelayedBarTimer()
  {
    this.stopDelayedBarTimer();      
    this.startDelayedBarTimer();
  }

  startDelayedBarTimer()
  {
    
    if (this.bar) {
      this.delayedBarTimer = setTimeout(()=>{
        PcDbg.log(CRASHDBG, "barTimer", PcConfig.scenario.payment.delayedStartBarTimeout,  "done, starting progress bar");
        this.bar_ref.current.start();
      }, PcConfig.scenario.payment.delayedStartBarTimeout*1000);
   }
  }

  stopDelayedBarTimer(restart=false)
  {
    
    if (this.delayedBarTimer) {
      PcDbg.log(CRASHDBG, "stop bar + timer");
      this.bar_ref.current.stop();
      clearTimeout(this.delayedBarTimer);      
    }
    if(restart) {
      this.startDelayedBarTimer();
    } 
  }

  onEndProgress(restart=false) //default from PcScreen (parent)
  {
    PcDbg.log(CRASHDBG, `PcScreen onEndProgress enter as ${this.constructor["name"]}`);    
    this.stopDelayedBarTimer(restart);
  }
  componentDidUpdate()
  {
    this.componentDidStuff();
  }

  componentDidMount()
  {
    this.componentDidStuff();
  }
 
  componentDidStuff()
  {
    PcDbg.log(CRASHDBG, `PcScreen componentDidStuff enter as ${this.constructor["name"]} with payment_active ${PcConfig.scenario.payment.active}`);
    if (!this.props.active) {
      PcDbg.log(CRASHDBG, `${this.constructor["name"]} not active`);
      return;
    }
    if (this.bar) {
      PcDbg.log(CRASHDBG, `${this.constructor["name"]} has bar, start timer`);
    }
    this.resetDelayedBarTimer();
    
  }

  registerButton(button, group="")
  {
    this.registeredButtons.push({button:button, group:group});
  }

  normalizeButtonsWidth(group = "")
  {
    var max = 0;
    var w = 0;

    for (var i=0; i<this.registeredButtons.length; i++)
    {
        if (this.registeredButtons[i].button.current)
        {
          w = this.registeredButtons[i].button.current.getWidth();
          if (w>max) max = w;
        }
    }

    for (var i=0; i<this.registeredButtons.length; i++)
    {
      if (this.registeredButtons[i].button.current)
      {
        w = this.registeredButtons[i].button.current.getWidth();
        if (w<max) this.registeredButtons[i].button.current.setWidth(max);
      }
    }
  }
}
