class PcScreenIntro extends PcScreen
{
  onClick(e)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    PcConfig.sounds.buttonNext.play();
    this.props.goNextScreen();
  }

  render()
  {
    if (!this.props.active) return null;
    let intro_label;
    var payment_active = PcConfig.scenario.payment.active;
    // do we already have a credit? 
    var payment_credit = parseInt(PcConfig.coalesce(PcConfig.cabin_status_xml.payment_credit, "_value"));
    /*
    if we are in ept mode and there is a credit, print intro.titleWithCredit (if exists, else fallback to intro.title)
    else (=if we are in non ept mode, or ept mode without credit), print regular intro title
    */
    if (payment_active && payment_credit != 0 && PcConfig.screen.intro.titleWithCredit != "" ) {
      intro_label = PcConfig.screen.intro.titleWithCredit;
    }
    else {
      intro_label = PcConfig.screen.intro.title;
    }

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.state.animationStyle
        },
        onClick:(e)=>{this.onClick(e)},
        onTouchEnd:(e)=>{this.onClick(e)}
      },
        e('div',
        {
          style:
          {
            position:"absolute",
            width:this.props.width*0.9,
            height:this.props.height*0.2,
            left:this.props.width*0.05,
            top:this.props.height*(PcConfig.screen.intro.titlePosition=="top" ? 0.05 : (PcConfig.screen.intro.titlePosition=="bottom" ? 0.75 : 0.4)),
            animation : "introLoop 5s infinite",
          }
        },
          e(PcLabel,
            {
              label:intro_label,
              title:true,
              width:this.props.width*0.9,
              height:this.props.height*0.2,
              x:0,
              y:0,
              fontSize:PcConfig.scenario.fontSizeGiant,
              color:PcConfig.screen.intro.titleColor,
              valign:PcConfig.screen.intro.titlePosition,
              noAnimation:true,
              showDelay:"0.1s"
            }
          )
        )
    );
  }
}
