<?php
const CRASHDBG = true;
if(DEVICE_ID == '')
{
	session_start() ;
	ini_set('session.cookie_lifetime', 60 * 60 * 24 * 31);
	ini_set('session.gc_maxlifetime', 60 * 60 * 24 * 31);
}

function isLocal()
{
	return strpos(BASE, DOMAIN_NAME) === false ;
}

function getParam($key, $aData, $default = '')
{
	return array_key_exists($key, $aData) ? $aData[$key] : $default ;
}

function getParamFromAll($key, $default = '')
{
	if (array_key_exists($key, $_GET))
	{
		return $_GET[$key] ;
	}else {
		if (array_key_exists($key, $_POST))
		{
			return $_POST[$key] ;
		}
	}
	
	return $default ;
}

function getFilePath($cabine_dir, $file, $dir = 'photos')
{
	$dirDate = date('Ym') ;
	
	$path = dirname(dirname(__FILE__)) . '/' . $dir . '/' ;
	
	$pathDir = '' ;
	$pathDir .= $cabine_dir . '/' ;
	if (!file_exists($path . $pathDir)) mkdir($path . $pathDir, 0777) ;
	
	$pathDir .= $dirDate . '/' ;
	if (!file_exists($path . $pathDir)) mkdir($path . $pathDir, 0777) ;
	
	return $pathDir . $file ;
}

function uploadFile($aFile, $file, $dir = 'photos')
{
	if ($aFile['error']) return ;

	$a = explode('.', $aFile['name']) ;
	$ext = strtolower($a[count($a) - 1]) ;
	
	$path = dirname(dirname(__FILE__)) . '/' . $dir . '/' ;
	
	move_uploaded_file($aFile['tmp_name'], $path . $file) ;
}

function loadConfig($config)
{
	$oConfigXml = null;
	$dir    = dirname(dirname(__FILE__)) . '/' ;
	$file = $dir . $config;
	if (file_exists($file)) {
		$oConfigXml = simplexml_load_file($dir . $config);
	}
	
	return $oConfigXml ;
}

function replaceBackLine($str)
{
	$str = str_replace(chr(10), '',  $str) ;
	$str = str_replace(chr(13), '<br/>', $str) ;
	
	return $str ;
}

function replaceBr($str)
{
	$str = str_replace('<br/>', chr(13), $str) ;
	
	return $str ;
}

function generateCode($length = 8)
{
	$text = '' ;
	
	for($i=0; $i < $length; $i++)
	{
		$text .= rand(0, 10) < 8 ? chr(rand(97, 122)) : chr(rand(48, 57)) ;
	}
	
	return $text ;
}

function _mktime($date)
{
	if(!$date) return mktime() ;
	
	$h	= substr($date, 11, 2) ;
	$mn	= substr($date, 14, 2) ;
	$s	= substr($date, 17, 2) ;
	
	$d = substr($date, 8, 2) ;
	$m = substr($date, 5, 2) ;
	$y = substr($date, 0, 4) ;
	
	return mktime($h, $mn, $s, $m, $d, $y) ;
}

function formatDate($sDate, $format = '%d %b %Y')
{
	setlocale(LC_ALL, 'fr_FR');
	return utf8_encode(strftime(utf8_decode($format), is_numeric($sDate) ? $sDate : _mktime($sDate))) ;
}

function is_server_reachable()
{
    $connected = @fsockopen(APP_FQDN, 80, $errno, $errstr, 5) ;
    if ($connected)
	{
        $is_conn = true;
        fclose($connected);
    }else{
        $is_conn = false;
    }
    return $is_conn;
}

function has_changedChecksum($file, $checksum)
{
	$fe = file_exists($file);
	dbg(false, "file_exists? ". $file .json_encode($fe) );
    $sum = $fe ? md5_file($file) : '' ;
	
	return $sum != $checksum ;
}

function has_changed($file, $url)
{
    $local = file_exists($file) ? filemtime($file) : -1 ;
	
	$a = get_headers($url, 1) ;
	
	if (!is_array($a)) return false ;
	
	$online = array_key_exists('Last-Modified', $a) ? strtotime($a['Last-Modified']) : 0 ; 
	
	//echo $local . '/' .  $online ;
	
	return strpos($a[0], '200') && $local < $online ;
}

function downloadFile($url, $file)
{
	//echo 'downloadFile =>' . $url . ' to ' . $file . '<br/>' ;

	//if (!has_changed($file, $url)) return ;
	
	$content = file_get_contents($url) ;
	
	if ($content !== false)
	{
		//unlink($file) ;
		file_put_contents($file, $content) ;
		touch($file) ;
		chmod($file, 0777) ;
	}
}

function compareName($a, $b) 
{
	return strcasecmp($a['name'], $b['name']);
}

function compareDate($a, $b) 
{
	return $a['date'] > $b['date'];
}

function getConfigFiles($folder = '')
{
	$aXmls = array() ;

	$dir    = dirname(dirname(__FILE__)) . '/xml/' . ($folder ? ($folder . '/') : '') ;
	$files  = scandir($dir);
	
	foreach($files as $file)
	{
		if (substr($file, -3, 3) == 'xml' && substr($file, 0, 6) != 'config') array_push($aXmls, $file) ;
	}
	
	return $aXmls ;
}

function saveXmlNode($tag, $key, $default = '')
{
	$xml = '<' . $tag . '>' ;
	for($i = 1 ; $i <= NB_LANGS ; $i++)
	{
		$xml .= '<lang' . $i . '><![CDATA[' . getParam($key . $i, $_POST, $default) . ']]></lang' . $i . '>' ;
	}
	$xml .= '</' . $tag . '>' ;
	
	return $xml ;
}

function saveXmlNode2($tag, $oXml)
{
	$xml = '<' . $tag . '>' ;
	for($i = 1 ; $i <= NB_LANGS ; $i++)
	{
		$str = 'lang' . $i ;
		$xml .= '<lang' . $i . '><![CDATA[' . $oXml->$str . ']]></lang' . $i . '>' ;
	}
	$xml .= '</' . $tag . '>' ;
	
	return $xml ;
}

function isOldXmlFile($file)
{
	$dir    = dirname(dirname(__FILE__)) . '/xml/old/' ;
	
	return file_exists($dir . $file) ;
}

function isConfiguratorXmlFile($file)
{
	$dir    = dirname(dirname(__FILE__)) . '/xml/configurateur/' ;
	
	return file_exists($dir . $file) ;
}


function getXmlFile($file, $folder = '')
{
	$dir    = dirname(dirname(__FILE__)) . '/xml/' ;
	
	if (!$folder && !file_exists($dir. $file) && file_exists($dir. 'old/' . $file)) $folder = 'old' ;
	if (!$folder && !file_exists($dir. $file) && file_exists($dir. 'configurateur/' . $file)) $folder = 'configurateur' ;
	
	return $dir . ($folder ? ($folder . '/') : '') . $file ;
}

function mergeXML(&$base, $add) 
{ 
    if ( $add->count() != 0 ) 
        $new = $base->addChild($add->getName()); 
    else 
        $new = $base->addChild($add->getName(), $add); 
    foreach ($add->attributes() as $a => $b) 
    { 
        $new->addAttribute($a, $b); 
    } 
    if ( $add->count() != 0 ) 
    { 
        foreach ($add->children() as $child) 
        { 
            mergeXML($new, $child); 
        } 
    } 
} 

function startsWith($string, $startString)
{
  $len = strlen($startString);
  return substr($string, 0, $len) === $startString;
}

function getCompletePathOnce($file, $dir) 
{
	$prefix = "";
	if (!startsWith($file, $dir)) {
		$prefix = $dir;
	}
	$ret = $prefix . $file ;
	// dbg(true, $file . "-> " . $ret);
	return $ret;
}
function getPhotoFile($file)
{
	$dir    = dirname(dirname(__FILE__)) . '/photos/' ;
	$ret = getCompletePathOnce($file, $dir); // for safety, just in case: now if a full path to a photo is already given, don't add the full path again
	return $ret;
}

function getVideoFile($file)
{
	$dir    = dirname(dirname(__FILE__)) . '/videos/' ;
	
	return $dir . $file ;
}

function getRessourceFile($file)
{
	$dir    = dirname(dirname(__FILE__)) . '/' ;
	
	return $dir . $file ;
}

function getPhotoUrl($file)
{
	$dir    = BASE . 'photos/' ;
	
	return $dir . $file ;
}

function getVideoUrl($file)
{
	$dir    = BASE . 'videos/' ;
	
	return $dir . $file ;
}

function getRessourceUrl($file)
{
	return BASE . $file ;
}

function checksumRessource($file)
{
	$dir    = dirname(dirname(__FILE__)) . '/' ;

	return $file && file_exists($dir . $file) ? md5_file($dir . $file) : '' ;
}

function writeRessourceXmlLine($node, $file)
{
	$xml = '<' . $node . ' ressource="1" checksum="' . checksumRessource($file) . '">' . $file . '</' . $node . '>' ;
	
	return $xml ;
}

function getPhotoId($photo)
{
	$ffile = array_pop(explode('/', $photo->file)) ;
	$l = strlen($photo->config) ;
	$file = substr($ffile, $l ? ($l + 1) : 0, strlen($ffile) - $l - ($l ? 5 : 4)) ;
	
	return $file ;
}

function transform_links($str, $photo)
{
	preg_match_all('/href="([^"]+)"/i', $str, $aMatchs) ;
	
	if ($aMatchs)
	{
		//var_dump($aMatchs) ;
		//foreach($aMatchs[1] as $l)
		for ($i = 0 ; $i < count($aMatchs[1]) ; $i++)
		{
			$l = $aMatchs[1][$i] ;
			$strr = $aMatchs[0][$i] ;
			$link = $l . (strpos($l, '?') !== false ? '&' : '?') . 'id_photo=' . $photo->id_photo . '&email=' . $photo->email . '&photo=' . urlencode(getPhotoUrl($photo->file)) . '&video=' . ($photo->video ? urlencode(getVideoUrl($photo->video)) : '') . '&optin1=' . $photo->notif . '&optin2=' . $photo->notif2 . '&optin3=' . $photo->notif3 ;
			if($photo->form) $link .= '&form=' . str_replace('|-|', '|', $photo->form) ;
			$strr = str_replace($l, $link, $strr) ;
			
			$str = str_replace($aMatchs[0][$i], $strr, $str) ;
		}
	}

	return $str;
}

function findConfigByLoginAndPassword($login, $pwd, $bMd5 = false)
{
	$config_file = false ;

	$aXmlFiles = getConfigFiles() ;
	foreach($aXmlFiles as $file)
	{
		$xml 	= simplexml_load_file(getXmlFile($file));
		
		$password = $bMd5 ? md5($xml->board->password) : $xml->board->password ;
		if($login && $pwd && $xml->board && $login == $xml->board->login && $pwd == $password)
		{
			$config_file = $file ;
		}
	}
	
	if (!$config_file)
	{
		$folder	= 'old' ;
		$aXmlFiles = getConfigFiles($folder) ;
		foreach($aXmlFiles as $file)
		{
			$xml 	= simplexml_load_file(getXmlFile($file, $folder));
			
			$password = $bMd5 ? md5($xml->board->password) : $xml->board->password ;
			if($login && $pwd && $xml->board && $login == $xml->board->login && $pwd == $password)
			{
				$config_file = $file ;
				$_SESSION['loggued_client'] = 1 ;
			}
		}
	}
	
	if (!$config_file)
	{
		$folder	= 'configurateur' ;
		$aXmlFiles = getConfigFiles($folder) ;
		foreach($aXmlFiles as $file)
		{
			$xml 	= simplexml_load_file(getXmlFile($file, $folder));
			
			$password = $bMd5 ? md5($xml->board->password) : $xml->board->password ;
			if($login && $pwd && $xml->board && $login == $xml->board->login && $pwd == $password)
			{
				$config_file = $file ;
				$_SESSION['loggued_client'] = 1 ;
			}
		}
	}
	
	return $config_file ;
}

function md5_fileOliv($file)
{
	$content = file_exists($file) ? file_get_contents($file) : md5($file) ;
	
	$content = preg_replace('/<time>([^<]+)<\/time>/i' , '', $content) ;
	$content = preg_replace('/<board>(.+)<\/board>/i' , '', $content) ;
	$content = preg_replace('/<social>(.+)<\/social>/i' , '', $content) ;
	$content = preg_replace('/<email>(.+)<\/email>/i' , '', $content) ;
	$content = preg_replace('/<vsocial>(.+)<\/vsocial>/i' , '', $content) ;
	$content = preg_replace('/<vemail>(.+)<\/vemail>/i' , '', $content) ;
	
	return md5($content) ;
}

function sendSMS($params)
{
	$login 		= '33786534761' ;
	$password 	= 'l3djam4luv' ;
	
	$url = 'https://' . $login . ':' . $password . '@' ;
	$url.= 'www.envoyersmspro.com/api/' ;
	$url.= 'message/send' ;
	if($params && count($params))
	{
		$i = 0 ;
		foreach($params as $k => $v)
		{
			$url.= $i ? '&' : '?' ;
			$url.= $k . '=' . urlencode($v) ;
			$i++ ;
		}
	}
	
	$ch = curl_init();	
	$opts[CURLOPT_CONNECTTIMEOUT] 	= 10 ;
	$opts[CURLOPT_RETURNTRANSFER] 	= true ;
	$opts[CURLOPT_TIMEOUT] 			= 60 ;
	$opts[CURLOPT_URL] 				= $url ;
	$opts[CURLOPT_SSL_VERIFYPEER] 	= false;
	$opts[CURLOPT_SSL_VERIFYHOST] 	= 2;
	
	//echo $url ;
	
	curl_setopt_array($ch, $opts);
	$result = curl_exec($ch);
	
	curl_close($ch) ;
	
	return $result ;
}

function htmlentitiesOliv($str)
{
	$html = htmlentities($str, ENT_QUOTES, "UTF-8") ;
	$html = str_replace('&lt;br/&gt;', '<br/>', $html) ;
	$html = str_replace('&lt;b&gt;', '<b>', $html) ;
	$html = str_replace('&lt;/b&gt;', '</b>', $html) ;
	$html = str_replace('&lt;i&gt;', '<i>', $html) ;
	$html = str_replace('&lt;/i&gt;', '</i>', $html) ;
	$html = str_replace('&lt;u&gt;', '<u>', $html) ;
	$html = str_replace('&lt;/u&gt;', '</u>', $html) ;
	
	return $html ;
}

function checkPrinterState()
{
	$xml = '<xml><counter>100</counter><status>ok</status></xml>' ;
	
	if(isLocal())
	{
		$cmd = dirname(dirname(__FILE__)) . "/printer/printerinfos.exe";
		$xml = exec($cmd);
	}
	
	return simplexml_load_string ($xml) ;
}

/*
if(!defined('STDIN'))  define('STDIN',  fopen('php://stdin',  'rb'));
if(!defined('STDOUT')) define('STDOUT', fopen('php://stdout', 'wb'));
if(!defined('STDERR')) define('STDERR', fopen('php://stderr', 'wb'));
*/
function dbg($cond, $log)
{
	//error_log("cond: " . $cond . " verif: " . ($cond ===false));
	if ($cond === false || $cond == 0 ) { // warning, binary combinations of flags (TOTODBG|TATADBG) gives an int, not a bool
		return;
	}
	$key = array_search(__FUNCTION__, array_column(debug_backtrace(), 'function'));
	$filename = debug_backtrace()[$key]['file'];
	$offsets_count = count(debug_backtrace());
	$offset = min($offsets_count, 1);
	$function ="";
	if (isset(debug_backtrace()[$offset])) // && isset(debug_backtrace()[$offset]['function'] ))
	{
		$function = debug_backtrace()[$offset]['function'];
	}
	$s  = sprintf("%s", basename($filename) . ": ");
	$s .= sprintf("%s", $function . ": ");
	$s .= sprintf("%s", $log . "\n");
	//print($s);
	error_log($s);
}

function var_error_log( $object=null ){
    ob_start();                    // start buffer capture
    var_dump( $object );           // dump the values
    $contents = ob_get_contents(); // put the buffer into a variable
    ob_end_clean();                // end capture
    error_log( $contents );        // log contents of the result of var_dump( $object )
}

function get_media_filename($jpg_filename, $isId, $saveFormat, $doRemoveBg) 
{

	$formats = array( "zip" => ZIP_EXT, "jpg" => JPG_EXT, "jpeg" => JPG_EXT, "png" => PNG_EXT, "gif" => GIF_EXT );
	$ext = $formats[$saveFormat];
		
	dbg(CRASHDBG, "jpg_filename: " . $jpg_filename . " isId: " . $isId . " saveFormat:" . $saveFormat . " doRemoveBg: " . $doRemoveBg);
	$mid_suffix ="";
	if ($isId != 0 || $isId == true) { // id implies suffix before extension
		$mid_suffix .= "_id";
	}
	if ($doRemoveBg) {
		$mid_suffix .= "_removebg";
	}
	$final_suffix = $mid_suffix . $ext;

	$file 	= str_replace(JPG_EXT, $final_suffix, $jpg_filename) ;
	dbg(CRASHDBG, "returning filename: " . $file);
	return $file;
}

function my_die($string) 
{
	dbg(true, "die: " . $string);
	throw new Exception($string);
	//die($string);
}
include_once('sql_functions.php');

