<?php
require_once 'synchronize_common.php';

if (my_ping() != 0) {
    dbg(true, "skipping");
}

const TABLE = 'photocabine_auto_jobs_payment';
const SELECT_LIMIT = 30;
// Sync payments online
$sql     = 'SELECT * FROM '. TABLE . ' WHERE sync IS NULL AND error_code IS NOT NULL ORDER BY id DESC LIMIT ' . SELECT_LIMIT;  ;
$payments     = my_selectAll($db, $sql);

foreach($payments as $payment)
{
    $sql = 'SELECT device FROM photocabine_status WHERE id = ' . $payment->id_photocabine_status . ' ORDER BY date DESC LIMIT 0,1';
    $sel_device = my_select($db, $sql);
    if (!isset($sel_device->device)) {
        dbg(true, "ERROR, payment $payment->id has a id_photocabine_status $payment->id_photocabine_status that doesn't match any device in photocabine_status! SKIPPING");
        continue;
    }

    $params = get_object_vars($payment) ; // convert db line to hashtable for curl post fields
    $params['device'] = $sel_device->device;

    #remove useless fields, must not be sent
    unset($params['id_photocabine_status']);
    unset($params['id']);
    unset($params['worker_pid']);
    unset($params['sync']);

    #prepare upload (curl http post)
    $ch = curl_init();    
    $opts =  array(
        CURLOPT_CONNECTTIMEOUT => 10,
        CURLOPT_RETURNTRANSFER => true, // returns the output of the page instead of the curl_exec value
        CURLOPT_TIMEOUT        => 600
      );

    $opts[CURLOPT_POSTFIELDS] = $params;
    $site_prefix = SSITE; 
    $opts[CURLOPT_URL] = $site_prefix . '/scripts/upload_payment.php';

    curl_setopt_array($ch, $opts);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false);

    $curl_result = my_curl_exec($ch);
    dbg(EXECDBG, "curl_result: " . $curl_result) ; 

    dbg(EXECDBG, json_encode($params));
    dbg(EXECDBG, json_encode("my_curl_exec: $curl_result"));


    if ($curl_result == '1')  {
      my_update($db, TABLE, array('sync' => 1), 'id = ' . $payment->id) ;
      echo "ok sync";
    } else {        
        echo "ko sync";
		echo ('Erreur Curl : ' . curl_error($ch));
    }
   
}


?>
